"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var util_1 = require("./util");
function githubApiRequest(path) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, util_1.downloadUrlAsJson("https://api.github.com/" + path, {
                        headers: {
                            'User-Agent': 'npm module get-powershell'
                        }
                    })];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.githubApiRequest = githubApiRequest;
function getAllReleases(user, repo) {
    if (user === void 0) { user = 'PowerShell'; }
    if (repo === void 0) { repo = 'PowerShell'; }
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var releases;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, githubApiRequest("repos/" + user + "/" + repo + "/releases")];
                case 1:
                    releases = _a.sent();
                    return [2 /*return*/, releases.map(function (r) { return parseShaSumsForRelease(r); })];
            }
        });
    });
}
exports.getAllReleases = getAllReleases;
function parseShaSumsForRelease(r) {
    var sha256Sums = {};
    r.body.replace(/-\s+([^ \r\n]+)\s*(?:\r\n|\n|\r)\s+-\s+([0-9A-F]{64})\s*(?:\r|\n)/g, function (all, name, sha) {
        sha256Sums[name] = sha;
        return '';
    });
    return tslib_1.__assign({}, r, { assets: r.assets.map(function (a) { return (tslib_1.__assign({}, a, { sha256: sha256Sums[a.name] })); }) });
}
